import {EventEmitter} from 'events';

function ctaOverHandler(e) {
  console.log('Auto Expand cta over')
}

function ctaOutHandler(e) {
  console.log('Auto Expand cta out')
}

function closeOverHandler(e) {
  console.log('Auto Expand Close over')
}

function closeOutHandler(e) {
  console.log('Auto Expand Close out')
}

function nextOverHandler(e) {
  console.log('Auto Expand Next over')
}

function nextOutHandler(e) {
  console.log('Auto Expand Next out')
}

function bind() {
  document.querySelector('#expandedContainer .cta').addEventListener('mouseover', ctaOverHandler);
  document.querySelector('#expandedContainer .cta').addEventListener('mouseout', ctaOutHandler);
  document.querySelector('#expandedContainer .cta').addEventListener('click', ctaOutHandler);
  document.querySelector('#expandedContainer .close').addEventListener('mouseover', closeOverHandler);
  document.querySelector('#expandedContainer .close').addEventListener('mouseout', closeOutHandler);
  document.querySelector('#expandedContainer .close').addEventListener('click', closeOutHandler);
  document.querySelector('#expandedContainer .nextPanel').addEventListener('mouseover', nextOverHandler);
  document.querySelector('#expandedContainer .nextPanel').addEventListener('mouseout', nextOutHandler);
  document.querySelector('#expandedContainer .nextPanel').addEventListener('click', nextOutHandler);
}

function unbind() {
  document.querySelector('#expandedContainer .cta').removeEventListener('mouseover', ctaOverHandler);
  document.querySelector('#expandedContainer .cta').removeEventListener('mouseout', ctaOutHandler);
  document.querySelector('#expandedContainer .cta').removeEventListener('click', ctaOutHandler);
  document.querySelector('#expandedContainer .close').removeEventListener('mouseover', closeOverHandler);
  document.querySelector('#expandedContainer .close').removeEventListener('mouseout', closeOutHandler);
  document.querySelector('#expandedContainer .close').removeEventListener('click', closeOutHandler);
  document.querySelector('#expandedContainer .nextPanel').removeEventListener('mouseover', nextOverHandler);
  document.querySelector('#expandedContainer .nextPanel').removeEventListener('mouseout', nextOutHandler);
  document.querySelector('#expandedContainer .nextPanel').removeEventListener('click', nextOutHandler);
}

export function animateIn() {
  let content = document.querySelector('#expandedContainer .content');
  let startHandler = function (e) {
    console.log('AUTO Expand animateIn START');
    tl.ee.emit('start', tl)
  };
  let completeHandler = function (e) {
    console.log('AUTO Expand animateIn COMPLETE');
    bind();
    tl.ee.emit('complete', tl);
    tl.ee.removeAllListeners();
  };
  let tl = new TimelineMax({
    onStart: startHandler,
    onComplete: completeHandler,
  });
  tl.ee = new EventEmitter();
  tl.add([
    TweenMax.to(content, 1, {opacity: 1})
  ]);
  return tl;
}

export function animateOut() {
  unbind();
  let content = document.querySelector('#expandedContainer .content');
  let startHandler = function (e) {
    console.log('AUTO Expand animateOut START');
    tl.ee.emit('start', tl)
  };
  let completeHandler = function (e) {
    console.log('AUTO Expand animateOut COMPLETE');
    tl.ee.emit('complete', tl);
    tl.ee.removeAllListeners();
  };
  let tl = new TimelineMax({
    onStart: startHandler,
    onComplete: completeHandler,
  });
  tl.ee = new EventEmitter();
  tl.add([
    TweenMax.set(content, {display: 'none'})
  ]);
  return tl;
}