import {EventEmitter} from 'events';


function ctaOverHandler(e) {
  console.log('collapsed cta over')
}

function ctaOutHandler(e) {
  console.log('collapsed cta out')
}

function expandOverHandler(e) {
  console.log('collapsed Expand over')
}

function expandOutHandler(e) {
  console.log('collapsed Expand out')
}

function bind() {
  document.querySelector('#collapsedContainer .cta').addEventListener('mouseover', ctaOverHandler);
  document.querySelector('#collapsedContainer .cta').addEventListener('mouseout', ctaOutHandler);
  document.querySelector('#collapsedContainer .cta').addEventListener('click', ctaOutHandler);
  document.querySelector('#collapsedContainer .expand').addEventListener('mouseover', expandOverHandler);
  document.querySelector('#collapsedContainer .expand').addEventListener('mouseout', expandOutHandler);
  document.querySelector('#collapsedContainer .expand').addEventListener('click', expandOutHandler);
}

function unbind() {
  document.querySelector('#collapsedContainer .cta').removeEventListener('mouseover', ctaOverHandler);
  document.querySelector('#collapsedContainer .cta').removeEventListener('mouseout', ctaOutHandler);
  document.querySelector('#collapsedContainer .cta').removeEventListener('click', ctaOutHandler);
  document.querySelector('#collapsedContainer .expand').removeEventListener('mouseover', expandOverHandler);
  document.querySelector('#collapsedContainer .expand').removeEventListener('mouseout', expandOutHandler);
  document.querySelector('#collapsedContainer .expand').removeEventListener('click', expandOutHandler);
}

export function animateIn() {
  let content = document.querySelector('#collapsedContainer .content');
  let startHandler = function (e) {
  
    console.log('collapsed animateIn START');
    
    tl.ee.emit('start', tl)
  };
  let completeHandler = function (e) {
    bind();
    console.log('collapsed animateIn COMPLETE');
    tl.ee.emit('complete', tl);
    tl.ee.removeAllListeners();
  };
  let tl = new TimelineMax({
    onStart: startHandler,
    onComplete: completeHandler,
  });
  tl.ee = new EventEmitter();
  tl.add([
    TweenMax.to(content, 1, {opacity: 1})
  ]);
  return tl;
}

export function animateOut() {
  unbind();
  let content = document.querySelector('#collapsedContainer .content');
  let startHandler = function (e) {
    console.log('collapsed animateOut START');
    
    tl.ee.emit('start', tl)
  };
  let completeHandler = function (e) {
    console.log('collapsed animateOut COMPLETE');
    tl.ee.emit('complete', tl);
    tl.ee.removeAllListeners();
  };
  let tl = new TimelineMax({
    onStart: startHandler,
    onComplete: completeHandler,
  });
  tl.ee = new EventEmitter();
  tl.add([
    TweenMax.set(content, {display: 'none'})
  ]);
  return tl;
}