import {animateExpand, animateCollapse} from '../Panels/Common'

export default function (adKit, config, expandedPanel, collapsedPreloader, expandedPreloader) {
  return new Promise(function (resolve, reject) {
    let expPanel = new expandedPanel();
    
    function collapse() {
      adKit.requestCollapse()
        .then(animateCollapse)
        .then(expPanel.exit)
        .then(expPanel.destroy)
        .then(function () {
          expPanel = null
        })
        .then(function () {
          collapsedPreloader.showPreloader();
        })
        .then(adKit.completeCollapse)
        .then(function () {
          resolve('Collapsed')
        })
    }
    
    function leaveExpanded() {
      expPanel.exit();
      expPanel.destroy();
      expPanel = null;
      resolve('Expanded')
    }
    
    function launch() {
      expPanel.preload()
        .then(expPanel.init)
        .then(animateExpand)
        .then(expandedPreloader.hidePreloader)
        .then(function () {
          expPanel.ee.on('catchall', function () {
              collapse();
              config.exits.catch_all()
            }
          );
          expPanel.ee.on('cta', function () {
            collapse();
            config.exits.cta()
          });
          expPanel.ee.once('close', function () {
            adKit.defaultClose();
            collapse()
          });
          expPanel.ee.once('next', function () {
            
            leaveExpanded()
          });
        })
        .then(adKit.completeExpand);
    }
    
    launch()
  });
}