import {animateExpand, animateCollapse} from '../Panels/Common'

export default function (adKit, config, collapsedPanel, expandedPanel, state, collapsedPreloader, expandedPreloader) {
  let cPanel = null;
  let expPanel = null;
  return new Promise(function (resolve, reject) {
    function collapse() {
      adKit.requestCollapse()
        .then(animateCollapse)
        .then(expPanel.exit)
        .then(expPanel.destroy)
        .then(function () {
          expPanel = null
        })
        .then(function () {
          collapsedPreloader.showPreloader();
        })
        .then(launch)
        .then(adKit.completeCollapse)
    }
    
    function expand() {
      return new Promise(function (resolve, reject) {
        expPanel = new expandedPanel();
        expandedPreloader.showPreloader();
        animateExpand();
        cPanel.exit();
        cPanel.destroy();
        expPanel.preload()
          .then(expPanel.init)
          .then(expandedPreloader.hidePreloader)
          .then(function () {
            expPanel.ee.on('catchall', function () {
                collapse();
                config.exits.catch_all()
              }
            );
            expPanel.ee.on('cta', function () {
              collapse();
              config.exits.cta()
            });
            expPanel.ee.once('close', function () {
              adKit.defaultClose();
              collapse()
            });
          })
          
          .then(function () {
            cPanel = null
          })
          .then(adKit.completeExpand);
      })
    }
    
    function launchExpanded() {
      return new Promise(function (resolve, reject) {
        expPanel = new expandedPanel();
        expandedPreloader.showPreloader();
        expPanel.preload()
          .then(expPanel.init)
          .then(expandedPreloader.hidePreloader)
          .then(function () {
            expPanel.ee.on('catchall', function () {
                collapse();
                config.exits.catch_all()
              }
            );
            expPanel.ee.on('cta', function () {
              collapse();
              config.exits.cta()
            });
            expPanel.ee.once('close', function () {
              adKit.defaultClose();
              collapse()
            });
          })
      })
    }
    
    function launch() {
      cPanel = new collapsedPanel();
      return new Promise(function (resolve, reject) {
        cPanel.preload()
          .then(function () {
            collapsedPreloader.hidePreloader();
          })
          .then(function () {
            cPanel.ee.on('catchall', config.exits.catch_all);
            cPanel.ee.on('cta',config.exits.cta);
            cPanel.ee.once('expand', () => {
              adKit.requestExpand()
                .then(expand)
            });
          })
          .then(cPanel.init)
          .then(function () {
            collapsedPreloader.hidePreloader();
          })
          .then(resolve);
      })
    }
    
    if (state === 'Expanded') {
      launchExpanded()
    } else {
      launch()
    }
  });
}