/**
 * optimize css in place for production
 * @tasks/optimize-css
 */
'use strict';

var htmlmin = require('gulp-htmlmin');
let injectSvg = require('gulp-inject-svg');
let preprocess = require('gulp-preprocess');
let gutil = require('gulp-util');
/**
 * @param gulp - function
 * @param options - object
 * options.src : Directory of images to optimize.
 * options.dist : Output directory.
 * @returns {Function}
 */
module.exports = function(gulp,  options, flags) {
  return function() {
  
    let onError = function (err) {
      console.log("!!! Rollup Error");
      gutil.beep();
      gutil.log(err);
      gutil.log(err.toString());
      del.sync(options.hackFile);
      this.emit('end');
    };
    
    return gulp.src(options.html.src)
      .pipe(preprocess({context: require('../../compiler-directives')}, {type: 'html'})).on('error', onError)
      .pipe(injectSvg()).on('error', onError)
      .pipe(htmlmin({collapseWhitespace: true,conservativeCollapse:true,removeComments:true}))
      .pipe(gulp.dest(options.dist))

  };
};


